/*----- PROTECTED REGION ID(Agilent33x20AClass.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Agilent33x20AClass.cpp
//
// description : C++ source for the Agilent33x20AClass.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the Agilent33x20A once per process.
//
// project :     Agilent 33x20a signal generator
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <tango.h>
#include <Agilent33x20A.h>
#include <Agilent33x20AClass.h>

/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass.cpp

//-------------------------------------------------------------------
/**
 *	Create Agilent33x20AClass singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Agilent33x20A_class(const char *name) {
		return Agilent33x20A_ns::Agilent33x20AClass::init(name);
	}
}

namespace Agilent33x20A_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Agilent33x20AClass *Agilent33x20AClass::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		Agilent33x20AClass::Agilent33x20AClass(string &s)
 * description : 	constructor for the Agilent33x20AClass
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Agilent33x20AClass::Agilent33x20AClass(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering Agilent33x20AClass constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Agilent33x20AClass::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::constructor

	cout2 << "Leaving Agilent33x20AClass constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		Agilent33x20AClass::~Agilent33x20AClass()
 * description : 	destructor for the Agilent33x20AClass
 */
//--------------------------------------------------------
Agilent33x20AClass::~Agilent33x20AClass()
{
	/*----- PROTECTED REGION ID(Agilent33x20AClass::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Agilent33x20AClass::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Agilent33x20AClass *Agilent33x20AClass::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new Agilent33x20AClass(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}		
	}		
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Agilent33x20AClass::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Agilent33x20AClass *Agilent33x20AClass::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		OnClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OnClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "OnClass::execute(): arrived" << endl;
	((static_cast<Agilent33x20A *>(device))->on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		OffClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OffClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "OffClass::execute(): arrived" << endl;
	((static_cast<Agilent33x20A *>(device))->off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ResetClass::execute(): arrived" << endl;
	((static_cast<Agilent33x20A *>(device))->reset());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : Agilent33x20AClass::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Agilent33x20AClass::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Agilent33x20AClass::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Agilent33x20AClass::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : Agilent33x20AClass::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Agilent33x20AClass::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : Agilent33x20AClass::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Agilent33x20AClass::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "GpibServer";
	prop_desc = "name of gpib device proxy e.g. sr/d-tm/hp33120-gpib";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : Agilent33x20AClass::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void Agilent33x20AClass::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("Agilent 33x20a signal generator");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("This class implements the standard signal generator interface for the Agilent 33120a");
	str_desc.push_back("and 33220a signal generators.");
	description << str_desc;
	data.push_back(description);

	//	put cvs or svn location
	string	filename("Agilent33x20A");
	filename += "Class.cpp";

	// check for cvs information
	string	src_path(CvsPath);
	start = src_path.find("/");
	if (start!=string::npos)
	{
		end   = src_path.find(filename);
		if (end>start)
		{
			string	strloc = src_path.substr(start, end-start);
			//	Check if specific repository
			start = strloc.find("/cvsroot/");
			if (start!=string::npos && start>0)
			{
				string	repository = strloc.substr(0, start);
				if (repository.find("/segfs/")!=string::npos)
					strloc = "ESRF:" + strloc.substr(start, strloc.length()-start);
			}
			Tango::DbDatum	cvs_loc("cvs_location");
			cvs_loc << strloc;
			data.push_back(cvs_loc);
		}
	}

	// check for svn information
	else
	{
		string	src_path(SvnPath);
		start = src_path.find("://");
		if (start!=string::npos)
		{
			end = src_path.find(filename);
			if (end>start)
			{
				header = "$HeadURL: ";
				start = header.length();
				string	strloc = src_path.substr(start, (end-start));
				
				Tango::DbDatum	svn_loc("svn_location");
				svn_loc << strloc;
				data.push_back(svn_loc);
			}
		}
	}

	//	Get CVS or SVN revision tag
	
	// CVS tag
	string	tagname(TagName);
	header = "$Name: ";
	start = header.length();
	string	endstr(" $");
	
	end   = tagname.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strtag = tagname.substr(start, end-start);
		Tango::DbDatum	cvs_tag("cvs_tag");
		cvs_tag << strtag;
		data.push_back(cvs_tag);
	}
	
	// SVN tag
	string	svnpath(SvnPath);
	header = "$HeadURL: ";
	start = header.length();
	
	end   = svnpath.find(endstr);
	if (end!=string::npos && end>start)
	{
		string	strloc = svnpath.substr(start, end-start);
		
		string tagstr ("/tags/");
		start = strloc.find(tagstr);
		if ( start!=string::npos )
		{
			start = start + tagstr.length();
			end   = strloc.find(filename);
			string	strtag = strloc.substr(start, end-start-1);
			
			Tango::DbDatum	svn_tag("svn_tag");
			svn_tag << strtag;
			data.push_back(svn_tag);
		}
	}

	//	Get URL location
	string	httpServ(HttpServer);
	if (httpServ.length()>0)
	{
		Tango::DbDatum	db_doc_url("doc_url");
		db_doc_url << httpServ;
		data.push_back(db_doc_url);
	}

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("Tango::Device_4Impl");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : Agilent33x20AClass::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Agilent33x20AClass::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Agilent33x20AClass::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new Agilent33x20A(this, (*devlist_ptr)[i]));							 
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Agilent33x20A *dev = static_cast<Agilent33x20A *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Agilent33x20AClass::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Agilent33x20AClass::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Agilent33x20AClass::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Agilent33x20AClass::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::attribute_factory_before
	//	Attribute : Frequency
	FrequencyAttrib	*frequency = new FrequencyAttrib();
	Tango::UserDefaultAttrProp	frequency_prop;
	frequency_prop.set_description("frequency");
	frequency_prop.set_label("Frequency");
	frequency_prop.set_unit("Hz");
	frequency_prop.set_standard_unit("Hz");
	frequency_prop.set_display_unit("Hz");
	frequency_prop.set_format("%10.3f");
	frequency_prop.set_max_value("15000000");
	frequency_prop.set_min_value("0.0001");
	//	max_alarm	not set for Frequency
	//	min_alarm	not set for Frequency
	//	max_warning	not set for Frequency
	//	min_warning	not set for Frequency
	//	delta_t	not set for Frequency
	//	delta_val	not set for Frequency
	
	frequency->set_default_properties(frequency_prop);
	//	Not Polled
	frequency->set_disp_level(Tango::OPERATOR);
	frequency->set_memorized();
	frequency->set_memorized_init(true);
	att_list.push_back(frequency);

	//	Attribute : Voltage
	VoltageAttrib	*voltage = new VoltageAttrib();
	Tango::UserDefaultAttrProp	voltage_prop;
	//	description	not set for Voltage
	voltage_prop.set_label("Voltage");
	voltage_prop.set_unit("Volt");
	voltage_prop.set_standard_unit("Volt");
	voltage_prop.set_display_unit("Volt");
	voltage_prop.set_format("%6.3f");
	voltage_prop.set_max_value("10");
	voltage_prop.set_min_value("0.05");
	//	max_alarm	not set for Voltage
	//	min_alarm	not set for Voltage
	//	max_warning	not set for Voltage
	//	min_warning	not set for Voltage
	//	delta_t	not set for Voltage
	//	delta_val	not set for Voltage
	
	voltage->set_default_properties(voltage_prop);
	//	Not Polled
	voltage->set_disp_level(Tango::OPERATOR);
	voltage->set_memorized();
	voltage->set_memorized_init(true);
	att_list.push_back(voltage);

	//	Attribute : VoltageOffset
	VoltageOffsetAttrib	*voltageoffset = new VoltageOffsetAttrib();
	Tango::UserDefaultAttrProp	voltageoffset_prop;
	//	description	not set for VoltageOffset
	voltageoffset_prop.set_label("voltage offset");
	voltageoffset_prop.set_unit("volt");
	voltageoffset_prop.set_standard_unit("V");
	voltageoffset_prop.set_display_unit("V");
	voltageoffset_prop.set_format("%6.3f");
	voltageoffset_prop.set_max_value("5");
	voltageoffset_prop.set_min_value("-5");
	//	max_alarm	not set for VoltageOffset
	//	min_alarm	not set for VoltageOffset
	//	max_warning	not set for VoltageOffset
	//	min_warning	not set for VoltageOffset
	//	delta_t	not set for VoltageOffset
	//	delta_val	not set for VoltageOffset
	
	voltageoffset->set_default_properties(voltageoffset_prop);
	//	Not Polled
	voltageoffset->set_disp_level(Tango::OPERATOR);
	voltageoffset->set_memorized();
	voltageoffset->set_memorized_init(true);
	att_list.push_back(voltageoffset);

	//	Attribute : Function
	FunctionAttrib	*function = new FunctionAttrib();
	Tango::UserDefaultAttrProp	function_prop;
	//	description	not set for Function
	function_prop.set_label("function");
	//	unit	not set for Function
	//	standard_unit	not set for Function
	//	display_unit	not set for Function
	function_prop.set_format("%s");
	//	max_value	not set for Function
	//	min_value	not set for Function
	//	max_alarm	not set for Function
	//	min_alarm	not set for Function
	//	max_warning	not set for Function
	//	min_warning	not set for Function
	//	delta_t	not set for Function
	//	delta_val	not set for Function
	
	function->set_default_properties(function_prop);
	//	Not Polled
	function->set_disp_level(Tango::OPERATOR);
	function->set_memorized();
	function->set_memorized_init(true);
	att_list.push_back(function);

	//	Attribute : SweepStartFrequency
	SweepStartFrequencyAttrib	*sweepstartfrequency = new SweepStartFrequencyAttrib();
	Tango::UserDefaultAttrProp	sweepstartfrequency_prop;
	sweepstartfrequency_prop.set_description("start sweep frequency");
	sweepstartfrequency_prop.set_label("Sweep start frequency");
	sweepstartfrequency_prop.set_unit("hz");
	sweepstartfrequency_prop.set_standard_unit("hz");
	sweepstartfrequency_prop.set_display_unit("hz");
	sweepstartfrequency_prop.set_format("%10.3f");
	sweepstartfrequency_prop.set_max_value("15000000");
	sweepstartfrequency_prop.set_min_value("0.01");
	//	max_alarm	not set for SweepStartFrequency
	//	min_alarm	not set for SweepStartFrequency
	//	max_warning	not set for SweepStartFrequency
	//	min_warning	not set for SweepStartFrequency
	//	delta_t	not set for SweepStartFrequency
	//	delta_val	not set for SweepStartFrequency
	
	sweepstartfrequency->set_default_properties(sweepstartfrequency_prop);
	//	Not Polled
	sweepstartfrequency->set_disp_level(Tango::OPERATOR);
	sweepstartfrequency->set_memorized();
	sweepstartfrequency->set_memorized_init(true);
	att_list.push_back(sweepstartfrequency);

	//	Attribute : SweepStopFrequency
	SweepStopFrequencyAttrib	*sweepstopfrequency = new SweepStopFrequencyAttrib();
	Tango::UserDefaultAttrProp	sweepstopfrequency_prop;
	sweepstopfrequency_prop.set_description("stop sweep frequency");
	sweepstopfrequency_prop.set_label("Sweep stop frequency");
	sweepstopfrequency_prop.set_unit("hz");
	sweepstopfrequency_prop.set_standard_unit("hz");
	sweepstopfrequency_prop.set_display_unit("hz");
	sweepstopfrequency_prop.set_format("%10.3f");
	sweepstopfrequency_prop.set_max_value("15000000");
	sweepstopfrequency_prop.set_min_value("0.01");
	//	max_alarm	not set for SweepStopFrequency
	//	min_alarm	not set for SweepStopFrequency
	//	max_warning	not set for SweepStopFrequency
	//	min_warning	not set for SweepStopFrequency
	//	delta_t	not set for SweepStopFrequency
	//	delta_val	not set for SweepStopFrequency
	
	sweepstopfrequency->set_default_properties(sweepstopfrequency_prop);
	//	Not Polled
	sweepstopfrequency->set_disp_level(Tango::OPERATOR);
	sweepstopfrequency->set_memorized();
	sweepstopfrequency->set_memorized_init(true);
	att_list.push_back(sweepstopfrequency);

	//	Attribute : SweepSpacing
	SweepSpacingAttrib	*sweepspacing = new SweepSpacingAttrib();
	Tango::UserDefaultAttrProp	sweepspacing_prop;
	sweepspacing_prop.set_description("Allowed values :\nLIN for linear\nLOG for logarithmic");
	sweepspacing_prop.set_label("spacing");
	//	unit	not set for SweepSpacing
	//	standard_unit	not set for SweepSpacing
	//	display_unit	not set for SweepSpacing
	sweepspacing_prop.set_format("%s");
	//	max_value	not set for SweepSpacing
	//	min_value	not set for SweepSpacing
	//	max_alarm	not set for SweepSpacing
	//	min_alarm	not set for SweepSpacing
	//	max_warning	not set for SweepSpacing
	//	min_warning	not set for SweepSpacing
	//	delta_t	not set for SweepSpacing
	//	delta_val	not set for SweepSpacing
	
	sweepspacing->set_default_properties(sweepspacing_prop);
	//	Not Polled
	sweepspacing->set_disp_level(Tango::OPERATOR);
	sweepspacing->set_memorized();
	sweepspacing->set_memorized_init(true);
	att_list.push_back(sweepspacing);

	//	Attribute : SweepTime
	SweepTimeAttrib	*sweeptime = new SweepTimeAttrib();
	Tango::UserDefaultAttrProp	sweeptime_prop;
	//	description	not set for SweepTime
	sweeptime_prop.set_label("Sweep time");
	sweeptime_prop.set_unit("second");
	sweeptime_prop.set_standard_unit("s");
	sweeptime_prop.set_display_unit("s");
	sweeptime_prop.set_format("%6.3f");
	sweeptime_prop.set_max_value("500");
	sweeptime_prop.set_min_value("0.001");
	//	max_alarm	not set for SweepTime
	//	min_alarm	not set for SweepTime
	//	max_warning	not set for SweepTime
	//	min_warning	not set for SweepTime
	//	delta_t	not set for SweepTime
	//	delta_val	not set for SweepTime
	
	sweeptime->set_default_properties(sweeptime_prop);
	//	Not Polled
	sweeptime->set_disp_level(Tango::OPERATOR);
	sweeptime->set_memorized();
	sweeptime->set_memorized_init(true);
	att_list.push_back(sweeptime);

	//	Attribute : TriggerSource
	TriggerSourceAttrib	*triggersource = new TriggerSourceAttrib();
	Tango::UserDefaultAttrProp	triggersource_prop;
	//	description	not set for TriggerSource
	triggersource_prop.set_label("trigger source");
	//	unit	not set for TriggerSource
	//	standard_unit	not set for TriggerSource
	//	display_unit	not set for TriggerSource
	triggersource_prop.set_format("%s");
	//	max_value	not set for TriggerSource
	//	min_value	not set for TriggerSource
	//	max_alarm	not set for TriggerSource
	//	min_alarm	not set for TriggerSource
	//	max_warning	not set for TriggerSource
	//	min_warning	not set for TriggerSource
	//	delta_t	not set for TriggerSource
	//	delta_val	not set for TriggerSource
	
	triggersource->set_default_properties(triggersource_prop);
	//	Not Polled
	triggersource->set_disp_level(Tango::OPERATOR);
	triggersource->set_memorized();
	triggersource->set_memorized_init(true);
	att_list.push_back(triggersource);

	//	Attribute : BurstCycles
	BurstCyclesAttrib	*burstcycles = new BurstCyclesAttrib();
	Tango::UserDefaultAttrProp	burstcycles_prop;
	burstcycles_prop.set_description("number of burst cycles when in burst mode");
	burstcycles_prop.set_label("burst cycles");
	burstcycles_prop.set_unit("cycles");
	burstcycles_prop.set_standard_unit("cycle");
	burstcycles_prop.set_display_unit("cycle");
	burstcycles_prop.set_format("%6d");
	burstcycles_prop.set_max_value("50000");
	burstcycles_prop.set_min_value("1");
	//	max_alarm	not set for BurstCycles
	//	min_alarm	not set for BurstCycles
	//	max_warning	not set for BurstCycles
	//	min_warning	not set for BurstCycles
	//	delta_t	not set for BurstCycles
	//	delta_val	not set for BurstCycles
	
	burstcycles->set_default_properties(burstcycles_prop);
	//	Not Polled
	burstcycles->set_disp_level(Tango::OPERATOR);
	burstcycles->set_memorized();
	burstcycles->set_memorized_init(true);
	att_list.push_back(burstcycles);

	//	Attribute : BurstPhase
	BurstPhaseAttrib	*burstphase = new BurstPhaseAttrib();
	Tango::UserDefaultAttrProp	burstphase_prop;
	burstphase_prop.set_description("the start phase of the signal generated when in burst mode");
	burstphase_prop.set_label("burst phase");
	burstphase_prop.set_unit("degrees");
	burstphase_prop.set_standard_unit("degrees");
	burstphase_prop.set_display_unit("degrees");
	burstphase_prop.set_format("%4.1f");
	burstphase_prop.set_max_value("360");
	burstphase_prop.set_min_value("-360");
	//	max_alarm	not set for BurstPhase
	//	min_alarm	not set for BurstPhase
	//	max_warning	not set for BurstPhase
	//	min_warning	not set for BurstPhase
	//	delta_t	not set for BurstPhase
	//	delta_val	not set for BurstPhase
	
	burstphase->set_default_properties(burstphase_prop);
	//	Not Polled
	burstphase->set_disp_level(Tango::OPERATOR);
	burstphase->set_memorized();
	burstphase->set_memorized_init(true);
	att_list.push_back(burstphase);

	//	Attribute : BurstRate
	BurstRateAttrib	*burstrate = new BurstRateAttrib();
	Tango::UserDefaultAttrProp	burstrate_prop;
	burstrate_prop.set_description("rate at which bursts will be generated when in burst mode");
	burstrate_prop.set_label("Burst rate");
	burstrate_prop.set_unit("hz");
	burstrate_prop.set_standard_unit("hz");
	burstrate_prop.set_display_unit("hz");
	burstrate_prop.set_format("%5.2f");
	burstrate_prop.set_max_value("50000");
	burstrate_prop.set_min_value("0.01");
	//	max_alarm	not set for BurstRate
	//	min_alarm	not set for BurstRate
	//	max_warning	not set for BurstRate
	//	min_warning	not set for BurstRate
	//	delta_t	not set for BurstRate
	//	delta_val	not set for BurstRate
	
	burstrate->set_default_properties(burstrate_prop);
	//	Not Polled
	burstrate->set_disp_level(Tango::OPERATOR);
	burstrate->set_memorized();
	burstrate->set_memorized_init(true);
	att_list.push_back(burstrate);

	//	Attribute : Mode
	ModeAttrib	*mode = new ModeAttrib();
	Tango::UserDefaultAttrProp	mode_prop;
	//	description	not set for Mode
	mode_prop.set_label("mode");
	//	unit	not set for Mode
	//	standard_unit	not set for Mode
	//	display_unit	not set for Mode
	mode_prop.set_format("%s");
	//	max_value	not set for Mode
	//	min_value	not set for Mode
	//	max_alarm	not set for Mode
	//	min_alarm	not set for Mode
	//	max_warning	not set for Mode
	//	min_warning	not set for Mode
	//	delta_t	not set for Mode
	//	delta_val	not set for Mode
	
	mode->set_default_properties(mode_prop);
	//	Not Polled
	mode->set_disp_level(Tango::OPERATOR);
	mode->set_memorized();
	mode->set_memorized_init(true);
	att_list.push_back(mode);

	//	Attribute : ModulationSource
	ModulationSourceAttrib	*modulationsource = new ModulationSourceAttrib();
	Tango::UserDefaultAttrProp	modulationsource_prop;
	//	description	not set for ModulationSource
	//	label	not set for ModulationSource
	//	unit	not set for ModulationSource
	//	standard_unit	not set for ModulationSource
	//	display_unit	not set for ModulationSource
	//	format	not set for ModulationSource
	//	max_value	not set for ModulationSource
	//	min_value	not set for ModulationSource
	//	max_alarm	not set for ModulationSource
	//	min_alarm	not set for ModulationSource
	//	max_warning	not set for ModulationSource
	//	min_warning	not set for ModulationSource
	//	delta_t	not set for ModulationSource
	//	delta_val	not set for ModulationSource
	
	modulationsource->set_default_properties(modulationsource_prop);
	//	Not Polled
	modulationsource->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(modulationsource);

	//	Attribute : ModulationFrequency
	ModulationFrequencyAttrib	*modulationfrequency = new ModulationFrequencyAttrib();
	Tango::UserDefaultAttrProp	modulationfrequency_prop;
	//	description	not set for ModulationFrequency
	//	label	not set for ModulationFrequency
	//	unit	not set for ModulationFrequency
	//	standard_unit	not set for ModulationFrequency
	//	display_unit	not set for ModulationFrequency
	//	format	not set for ModulationFrequency
	//	max_value	not set for ModulationFrequency
	//	min_value	not set for ModulationFrequency
	//	max_alarm	not set for ModulationFrequency
	//	min_alarm	not set for ModulationFrequency
	//	max_warning	not set for ModulationFrequency
	//	min_warning	not set for ModulationFrequency
	//	delta_t	not set for ModulationFrequency
	//	delta_val	not set for ModulationFrequency
	
	modulationfrequency->set_default_properties(modulationfrequency_prop);
	//	Not Polled
	modulationfrequency->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(modulationfrequency);

	//	Attribute : ModulationFunction
	ModulationFunctionAttrib	*modulationfunction = new ModulationFunctionAttrib();
	Tango::UserDefaultAttrProp	modulationfunction_prop;
	//	description	not set for ModulationFunction
	//	label	not set for ModulationFunction
	//	unit	not set for ModulationFunction
	//	standard_unit	not set for ModulationFunction
	//	display_unit	not set for ModulationFunction
	//	format	not set for ModulationFunction
	//	max_value	not set for ModulationFunction
	//	min_value	not set for ModulationFunction
	//	max_alarm	not set for ModulationFunction
	//	min_alarm	not set for ModulationFunction
	//	max_warning	not set for ModulationFunction
	//	min_warning	not set for ModulationFunction
	//	delta_t	not set for ModulationFunction
	//	delta_val	not set for ModulationFunction
	
	modulationfunction->set_default_properties(modulationfunction_prop);
	//	Not Polled
	modulationfunction->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(modulationfunction);

	//	Attribute : AMDepth
	AMDepthAttrib	*amdepth = new AMDepthAttrib();
	Tango::UserDefaultAttrProp	amdepth_prop;
	//	description	not set for AMDepth
	//	label	not set for AMDepth
	//	unit	not set for AMDepth
	//	standard_unit	not set for AMDepth
	//	display_unit	not set for AMDepth
	//	format	not set for AMDepth
	//	max_value	not set for AMDepth
	//	min_value	not set for AMDepth
	//	max_alarm	not set for AMDepth
	//	min_alarm	not set for AMDepth
	//	max_warning	not set for AMDepth
	//	min_warning	not set for AMDepth
	//	delta_t	not set for AMDepth
	//	delta_val	not set for AMDepth
	
	amdepth->set_default_properties(amdepth_prop);
	//	Not Polled
	amdepth->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(amdepth);

	//	Attribute : FMDeviation
	FMDeviationAttrib	*fmdeviation = new FMDeviationAttrib();
	Tango::UserDefaultAttrProp	fmdeviation_prop;
	//	description	not set for FMDeviation
	//	label	not set for FMDeviation
	//	unit	not set for FMDeviation
	//	standard_unit	not set for FMDeviation
	//	display_unit	not set for FMDeviation
	//	format	not set for FMDeviation
	//	max_value	not set for FMDeviation
	//	min_value	not set for FMDeviation
	//	max_alarm	not set for FMDeviation
	//	min_alarm	not set for FMDeviation
	//	max_warning	not set for FMDeviation
	//	min_warning	not set for FMDeviation
	//	delta_t	not set for FMDeviation
	//	delta_val	not set for FMDeviation
	
	fmdeviation->set_default_properties(fmdeviation_prop);
	//	Not Polled
	fmdeviation->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(fmdeviation);

	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Agilent33x20AClass::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : Agilent33x20AClass::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Agilent33x20AClass::command_factory()
{
	/*----- PROTECTED REGION ID(Agilent33x20AClass::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::command_factory_before


	//	Command On
	OnClass	*pOnCmd =
		new OnClass("On",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOnCmd);

	//	Command Off
	OffClass	*pOffCmd =
		new OffClass("Off",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOffCmd);

	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	/*----- PROTECTED REGION ID(Agilent33x20AClass::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Agilent33x20AClass::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list 
 */
//--------------------------------------------------------
void Agilent33x20AClass::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(Agilent33x20AClass::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Agilent33x20AClass::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Agilent33x20AClass::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{	
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		Agilent33x20A *dev = static_cast<Agilent33x20A *> (dev_impl);
		
		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Agilent33x20AClass::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : Agilent33x20AClass::get_attr_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Agilent33x20AClass::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; it++)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Agilent33x20AClass::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	Agilent33x20AClass::Additional Methods
} //	namespace
